# -*- coding: utf-8 -*-

"""
accountandtransactionapispecification

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from accountandtransactionapispecification.api_helper import APIHelper
from accountandtransactionapispecification.exceptions.api_exception import APIException
from accountandtransactionapispecification.models.error import Error


class Accounts403ErrorException(APIException):
    def __init__(self, reason, response):
        """Constructor for the Accounts403ErrorException class

        Args:
            reason (string): The reason (or error message) for the Exception
                to be raised.
            response (HttpResponse): The HttpResponse of the API call.

        """
        super(Accounts403ErrorException, self).__init__(reason, response)
        dictionary = APIHelper.json_deserialize(self.response.text)
        if isinstance(dictionary, dict):
            self.unbox(dictionary)

    def unbox(self, dictionary):
        """Populates the properties of this object by extracting them from a dictionary.

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        """
        self.code = dictionary.get("Code") if dictionary.get("Code") else None
        self.id = dictionary.get("Id") if dictionary.get("Id") else None
        self.message = dictionary.get("Message") if dictionary.get("Message") else None
        self.errors = None
        if dictionary.get('Errors') is not None:
            self.errors = [Error.from_dictionary(x) for x in dictionary.get('Errors')]

    def __str__(self):
        base_str = super().__str__()
        return (f'{self.__class__.__name__}('
                f'{base_str[base_str.find("(") + 1:-1]}, '
                f'code={self.code!s}, '
                f'id={(self.id if hasattr(self, "id") else None)!s}, '
                f'message={self.message!s}, '
                f'errors={self.errors!s})')
