# -*- coding: utf-8 -*-

"""
accountandtransactionapispecification

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from accountandtransactionapispecification.models.amount import Amount


class StatementBenefit(object):

    """Implementation of the 'StatementBenefit' model.

    Set of elements used to provide details of a benefit or reward amount for
    the statement resource.

    Attributes:
        amount (Amount): Amount of money of the cash balance.
        mtype (StatementBenefitTypeEnum): Benefit type, in a coded form.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "amount": 'Amount',
        "mtype": 'Type'
    }

    def __init__(self,
                 amount=None,
                 mtype=None):
        """Constructor for the StatementBenefit class"""

        # Initialize members of the class
        self.amount = amount 
        self.mtype = mtype 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        amount = Amount.from_dictionary(dictionary.get('Amount')) if dictionary.get('Amount') else None
        mtype = dictionary.get("Type") if dictionary.get("Type") else None
        # Return an object of this model
        return cls(amount,
                   mtype)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'amount={self.amount!r}, '
                f'mtype={self.mtype!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'amount={self.amount!s}, '
                f'mtype={self.mtype!s})')
